<?php

/**
 * Implements hook_views_data().
 */

  function custom_db_table_views_views_data() {
    $table_name = \Drupal::config('custom_db_table_views.settings')->get('db_table_name');
    $views_name = \Drupal::config('custom_db_table_views.settings')->get('db_views_name');

    if ($table_name!='' && $views_name!='') {
      $data = array();
      $data[$table_name] = array();
      $data[$table_name]['table'] = array();
      $data[$table_name]['table']['group'] = t('Id unique value');
      $data[$table_name]['table']['provider'] = 'custom_db_table_views';

      // Create object of DatabaseConfigurationSettings to get all table details //

      $db_setting = new DatabaseConfigurationSettings();
      $table_structure = $db_setting->custom_db_table($table_name);
      $primarykey= $db_setting->custom_db_table_primary_key($table_name);
      $total_col =count($table_structure);
        if($primarykey) {
        $pri_key = $primarykey['0']->column_name;
        } else {
        $pri_key = $table_structure[0]->column_name;
        }
      $data[$table_name]['table']['base'] = array(
      'field' => $pri_key,
      'title' => t($views_name),
      'help' => t('Get all filed of custom table.'),
      'weight' => -10,
      );

      for($i=1;$i<=$total_col-1;$i++) {
        $col_names  = $table_structure[$i]->column_name;
        $data[$table_name][$col_names] = array(
        'title' => t($col_names.' field'),
        'help' => t($col_names.' field.'),
        'field' => array(
        'id' =>'standard',),
        'sort' => array(
        'id' => 'standard',),
        'filter' => array(
        'id' => 'string',),
        'argument' => array(
        'id' => 'string',),
        );
      }
      return $data;
    }
  }
